package starterCode;


import starterCode.NetParams;
import starterCode.NetParams.TrainType;
import tests.NetChecker2;


/**
 * Class implementing a basic three-layer neural network.
 */
public class Net {

	/** The parameters. */
	public NetParams params;

	/** The checker that will verify the network's correctness. */
	public NetChecker2 checker;

	/** A bias unit with an output fixed at 1. It's not essential, 
	 * but it's handy as a placeholder for bias inputs. 
	 */
	public Unit Bias;
	
	/** Layers of units are represented as an array of arrays.
	 * This will support an arbitrary network depth.
	 * The vector units[0] is the input layer.
	 * The vector units[units.length-1] is the output layer.
	 * All other elements of units are the hidden layers.
	 * The bias unit(s) should not appear in this array!
	 */
	public Unit[][] units;

	/**
	 * Constructor for Net class.
	 * 
	 * Create Net with the specified architecture and data.
	 * 
	 * @param patterns Array of input patterns (each an array of int)
	 * @param targets Array of output patterns (each an array of int)
	 */
	public Net(NetParams params,
			NetChecker2 checker) {
		this.checker = checker;
		
		// TODO fill this in to initialize the net!
		
		if (this.checker != null)
			this.checker.initialize(this);
	}

	/**
	 * Present pattern and compute activations for rest of net.
	 * 
	 * @param pattern
	 *          An input training pattern
	 */
	public void feedforward(int[] pattern) {
		// TODO implement this!
	}

	/**
	 * Present all patterns to network and calculate current error. Current error
	 * is measured by sum of squared error on output nodes.
	 * 
	 * @return current network error
	 */
	public double computeError() {
		// TODO implement this!
		return 0;
	}

	/**
	 * Present target pattern and propagate error back.
	 *
	 * @param targets An output target pattern
	 *
	 */
	public void backprop(int[] target) {
		// TODO implement this!
	}

	/**
	 * Update weights in stochastic mode (i.e. updating after every datum).
	 */
	public void updateStochasticWeights() {
		// TODO implement this!
	}
	
	/**
	 * Accumulate the weight change of the current datum to apply at the end of
	 * the epoch, for batch mode.
	 * 
	 */
	public void accumulateWeightChange() {
		// TODO implement this!
	}
	
	/**
	 * Apply the accumulated weight change from the data of the epoch.
	 *
	 */
	public void updateAccumulatedWeights() {
		// TODO implement this!
	}
	
	/**
	 * Train the net according to the current training parameters for at most
	 * the given number of epochs.
	 * 
	 * Initialize weights and present patterns in order, updating weights after
	 * each pattern. Training continues until error falls below criterion, or
	 * when numEpochs epochs have elapsed, whichever comes first.
	 */
	public void train() {
		// TODO implement this! Don't forget to call the checker as follows:
		
		// for every training datum:
		//   checker.trainDatum(i);
		//   (do your computations here)
		//   checker.checkMyActivation(this);
		// if we're doing stochastic updates (at every datum), do this at every datum:
		//   checker.checkMyWeights(this);
		//   checker.checkMyMomentum(this);
		//   checker.checkMyWeightChange(this);
		// if we're doing batch mode updates (at every epoch), do this at every epoch:
		//   checker.checkMyWeights(this);
		//   checker.checkMyMomentum(this);
		//   checker.checkMyWeightChange(this);
	}
	
	/*
	 * Additional methods? To be filled in....
	 */

	/**
	 * toString()
	 * 
	 * A method to neatly dump the weights of each link
	 */
	public String toString() {
		String rStr = "\n";
		rStr += "Inputs: " + units[0].length + "\n";
		if (units.length > 2) {
			rStr += "Hidden layers: " + (units.length - 2)
					+ "; nodes per layer: " + units[1].length + "\n";
		} else {
			rStr += "No hidden layers\n";
		}
		rStr += "Outputs: " + units[units.length - 1].length + "\n";
		rStr += "Error: " + computeError() + "\n";
		rStr += "Weights: \n";

		boolean one_or_fewer_hidden_layers = units.length <= 3;
		for (int i = 1; i < units.length; i++) {
			String frLayer = (i == 1) ? "in"
					: one_or_fewer_hidden_layers ? "hid" : ("hid" + (i - 1));
			String toLayer = (i == units.length - 1) ? "out"
					: one_or_fewer_hidden_layers ? "hid" : ("hid" + i);
			for (int j = 0; j < units[i].length; j++) {
				for (int k = 0; k < units[i - 1].length; k++) {
					rStr += "   " + frLayer + "_" + k + " -> " + toLayer + "_"
							+ j + " = " + units[i][j].inWeights[k] + "\n";
				}
				rStr += "   bias -> "
						+ toLayer
						+ "_"
						+ j
						+ " = "
						+ units[i][j].inWeights[units[i][j].inWeights.length - 1]
						+ "\n";
			}
		}
		return rStr;
	}

}
